diff --git a/pki/base/silent/src/com/netscape/pkisilent/ConfigureDRM.java b/pki/base/silent/src/com/netscape/pkisilent/ConfigureDRM.java
index 7d15861d19afdb6b8e0d8eb77e3a4b7718593803..e368a3ab86f1854f581b03aeb73ec49db23ba08e 100644
--- a/pki/base/silent/src/com/netscape/pkisilent/ConfigureDRM.java
+++ b/pki/base/silent/src/com/netscape/pkisilent/ConfigureDRM.java
@@ -24,6 +24,7 @@ import java.io.ByteArrayInputStream;
 import java.io.FileInputStream;
 import java.io.FileOutputStream;
 import java.io.InputStreamReader;
+import java.io.UnsupportedEncodingException;
 import java.net.URLEncoder;
 import java.util.ArrayList;
 
@@ -95,7 +96,6 @@ public class ConfigureDRM {
     public static String base_dn = null;
     public static String db_name = null;
     public static String secure_conn = null;
-    public static String clone_start_tls = null;
     public static String remove_data = null;
 
     public static String key_type = null;
@@ -173,6 +173,9 @@ public class ConfigureDRM {
     public static String clone_uri = null;
     public static String clone_p12_passwd = null;
     public static String clone_p12_file = null;
+    public static String clone_master_port = null;
+    public static String clone_replica_port = null;
+    public static String clone_replication_security = null;
 
     //for correct selection of CA to be cloned
     public static String urls;
@@ -224,7 +227,7 @@ public class ConfigureDRM {
         return st;
     }
 
-    public boolean TokenChoicePanel() {
+    public boolean TokenChoicePanel() throws UnsupportedEncodingException {
         HTTPResponse hr = null;
         ByteArrayInputStream bais = null;
         ParseXML px = new ParseXML();
@@ -235,7 +238,7 @@ public class ConfigureDRM {
         if (token_name.equalsIgnoreCase("internal")) {
             query_string = "p=1" + "&op=next" + "&xml=true" +
                            "&choice=" +
-                           URLEncoder.encode("Internal Key Storage Token");
+                           URLEncoder.encode("Internal Key Storage Token", "UTF-8");
             hr = hc.sslConnect(cs_hostname, cs_port, wizard_uri, query_string);
 
             // parse xml
@@ -246,9 +249,9 @@ public class ConfigureDRM {
             // login to hsm first
             query_string = "p=2" + "&op=next" + "&xml=true" +
                             "&uTokName=" +
-                            URLEncoder.encode(token_name) +
+                            URLEncoder.encode(token_name, "UTF-8") +
                             "&__uPasswd=" +
-                            URLEncoder.encode(token_pwd);
+                            URLEncoder.encode(token_pwd, "UTF-8");
             hr = hc.sslConnect(cs_hostname, cs_port, wizard_uri, query_string);
 
             // parse xml
@@ -259,7 +262,7 @@ public class ConfigureDRM {
             // choice with token name now
             query_string = "p=1" + "&op=next" + "&xml=true" +
                            "&choice=" +
-                           URLEncoder.encode(token_name);
+                           URLEncoder.encode(token_name, "UTF-8");
             hr = hc.sslConnect(cs_hostname, cs_port, wizard_uri, query_string);
 
             // parse xml
@@ -271,7 +274,7 @@ public class ConfigureDRM {
         return true;
     }
 
-    public boolean DomainPanel() {
+    public boolean DomainPanel() throws UnsupportedEncodingException {
         HTTPResponse hr = null;
         ByteArrayInputStream bais = null;
         ParseXML px = new ParseXML();
@@ -279,7 +282,7 @@ public class ConfigureDRM {
         String domain_url = "https://" + sd_hostname + ":" + sd_admin_port;
 
         String query_string = "sdomainURL=" +
-                            URLEncoder.encode(domain_url) +
+                            URLEncoder.encode(domain_url, "UTF-8") +
                             "&choice=existingdomain" +
                             "&p=3" +
                             "&op=next" +
@@ -312,13 +315,13 @@ public class ConfigureDRM {
                             "/kra/admin/console/config/wizard" +
                             "?p=5&subsystem=KRA";
 
-            String query_string = "url=" + URLEncoder.encode(kra_url);
+            String query_string = "url=" + URLEncoder.encode(kra_url, "UTF-8");
 
             hr = hc.sslConnect(sd_hostname, sd_admin_port, sd_login_uri, query_string);
 
             String query_string_1 = "uid=" + sd_admin_name +
-                                "&pwd=" + URLEncoder.encode(sd_admin_password) +
-                                "&url=" + URLEncoder.encode(kra_url);
+                                "&pwd=" + URLEncoder.encode(sd_admin_password, "UTF-8") +
+                                "&url=" + URLEncoder.encode(kra_url, "UTF-8");
 
             hr = hc.sslConnect(sd_hostname, sd_admin_port, sd_get_cookie_uri,
                         query_string_1);
@@ -362,7 +365,7 @@ public class ConfigureDRM {
         }
     }
 
-    public boolean SubsystemPanel() {
+    public boolean SubsystemPanel() throws UnsupportedEncodingException {
         HTTPResponse hr = null;
         ByteArrayInputStream bais = null;
         ParseXML px = new ParseXML();
@@ -370,11 +373,11 @@ public class ConfigureDRM {
         if (!clone) {
             query_string = "p=5" + "&op=next" + "&xml=true"
                     + "&choice=newsubsystem" + "&subsystemName="
-                    + URLEncoder.encode(subsystem_name);
+                    + URLEncoder.encode(subsystem_name, "UTF-8");
         } else {
             query_string = "p=5" + "&op=next" + "&xml=true"
                     + "&choice=clonesubsystem" + "&subsystemName="
-                    + URLEncoder.encode(subsystem_name)
+                    + URLEncoder.encode(subsystem_name, "UTF-8")
                     + "&urls=" + urls;
         }
 
@@ -394,8 +397,8 @@ public class ConfigureDRM {
             ParseXML px = new ParseXML();
 
             String query_string = "p=6" + "&op=next" + "&xml=true"
-                    + "&__password=" + URLEncoder.encode(clone_p12_passwd)
-                    + "&path=" + URLEncoder.encode(clone_p12_file) + "";
+                    + "&__password=" + URLEncoder.encode(clone_p12_passwd, "UTF-8")
+                    + "&path=" + URLEncoder.encode(clone_p12_file, "UTF-8") + "";
 
             hr = hc.sslConnect(cs_hostname, cs_port, wizard_uri, query_string);
 
@@ -411,21 +414,23 @@ public class ConfigureDRM {
         }
     }
 
-    public boolean LdapConnectionPanel() {
+    public boolean LdapConnectionPanel() throws UnsupportedEncodingException {
         HTTPResponse hr = null;
         ByteArrayInputStream bais = null;
         ParseXML px = new ParseXML();
 
         String query_string = "p=7" + "&op=next" + "&xml=true" +
-                              "&host=" + URLEncoder.encode(ldap_host) +
-                              "&port=" + URLEncoder.encode(ldap_port) +
-                              "&binddn=" + URLEncoder.encode(bind_dn) +
-                              "&__bindpwd=" + URLEncoder.encode(bind_password) +
-                              "&basedn=" + URLEncoder.encode(base_dn) +
-                              "&database=" + URLEncoder.encode(db_name) +
-                              "&display=" + URLEncoder.encode("$displayStr") +
+                              "&host=" + URLEncoder.encode(ldap_host, "UTF-8") +
+                              "&port=" + URLEncoder.encode(ldap_port, "UTF-8") +
+                              "&binddn=" + URLEncoder.encode(bind_dn, "UTF-8") +
+                              "&__bindpwd=" + URLEncoder.encode(bind_password, "UTF-8") +
+                              "&basedn=" + URLEncoder.encode(base_dn, "UTF-8") +
+                              "&database=" + URLEncoder.encode(db_name, "UTF-8") +
+                              "&display=" + URLEncoder.encode("$displayStr", "UTF-8") +
                               (secure_conn.equals("true") ? "&secureConn=on" : "") +
-                              (clone_start_tls.equals("true") ? "&cloneStartTLS=on" : "") +
+                              "&masterReplicationPort=" + URLEncoder.encode(clone_master_port, "UTF-8") +
+                              "&cloneReplicationPort=" + URLEncoder.encode(clone_replica_port, "UTF-8") +
+                              "&replicationSecurity=" + URLEncoder.encode(clone_replication_security, "UTF-8") +
                               (remove_data.equals("true") ? "&removeData=true" : "");
 
         hr = hc.sslConnect(cs_hostname, cs_port, wizard_uri, query_string);
@@ -525,7 +530,7 @@ public class ConfigureDRM {
         return true;
     }
 
-    public boolean CertSubjectPanel() {
+    public boolean CertSubjectPanel() throws UnsupportedEncodingException {
         HTTPResponse hr = null;
         ByteArrayInputStream bais = null;
         ParseXML px = new ParseXML();
@@ -539,23 +544,23 @@ public class ConfigureDRM {
         if (!clone) {
             query_string = "p=9" + "&op=next" + "&xml=true" +
                     "&subsystem=" +
-                    URLEncoder.encode(drm_subsystem_cert_subject_name) +
+                    URLEncoder.encode(drm_subsystem_cert_subject_name, "UTF-8") +
                     "&transport=" +
-                    URLEncoder.encode(drm_transport_cert_subject_name) +
+                    URLEncoder.encode(drm_transport_cert_subject_name, "UTF-8") +
                     "&storage=" +
-                    URLEncoder.encode(drm_storage_cert_subject_name) +
+                    URLEncoder.encode(drm_storage_cert_subject_name, "UTF-8") +
                     "&sslserver=" +
-                    URLEncoder.encode(drm_server_cert_subject_name) +
+                    URLEncoder.encode(drm_server_cert_subject_name, "UTF-8") +
                     "&audit_signing=" +
-                    URLEncoder.encode(drm_audit_signing_cert_subject_name) +
+                    URLEncoder.encode(drm_audit_signing_cert_subject_name, "UTF-8") +
                     "&urls=" +
-                    URLEncoder.encode(domain_url);
+                    URLEncoder.encode(domain_url, "UTF-8");
         } else {
             query_string = "p=9" + "&op=next" + "&xml=true" +
                     "&sslserver=" +
-                    URLEncoder.encode(drm_server_cert_subject_name) +
+                    URLEncoder.encode(drm_server_cert_subject_name, "UTF-8") +
                     "&urls=" +
-                    URLEncoder.encode(domain_url);
+                    URLEncoder.encode(domain_url, "UTF-8");
         }
 
         hr = hc.sslConnect(cs_hostname, cs_port, wizard_uri, query_string);
@@ -595,26 +600,26 @@ public class ConfigureDRM {
         return true;
     }
 
-    public boolean CertificatePanel() {
+    public boolean CertificatePanel() throws UnsupportedEncodingException {
         HTTPResponse hr = null;
         ByteArrayInputStream bais = null;
         ParseXML px = new ParseXML();
 
         String query_string = "p=10" + "&op=next" + "&xml=true" +
                             "&subsystem=" +
-                            URLEncoder.encode(drm_subsystem_cert_cert) +
+                            URLEncoder.encode(drm_subsystem_cert_cert, "UTF-8") +
                             "&subsystem_cc=" +
                             "&transport=" +
-                            URLEncoder.encode(drm_transport_cert_cert) +
+                            URLEncoder.encode(drm_transport_cert_cert, "UTF-8") +
                             "&transport_cc=" +
                             "&storage=" +
-                            URLEncoder.encode(drm_storage_cert_cert) +
+                            URLEncoder.encode(drm_storage_cert_cert, "UTF-8") +
                             "&storage_cc=" +
                             "&sslserver=" +
-                            URLEncoder.encode(server_cert_cert) +
+                            URLEncoder.encode(server_cert_cert, "UTF-8") +
                             "&sslserver_cc=" +
                             "&audit_signing=" +
-                            URLEncoder.encode(drm_audit_signing_cert_cert) +
+                            URLEncoder.encode(drm_audit_signing_cert_cert, "UTF-8") +
                             "&audit_signing_cc=";
 
         hr = hc.sslConnect(cs_hostname, cs_port, wizard_uri, query_string);
@@ -627,15 +632,15 @@ public class ConfigureDRM {
         return true;
     }
 
-    public boolean BackupPanel() {
+    public boolean BackupPanel() throws UnsupportedEncodingException {
         HTTPResponse hr = null;
         ByteArrayInputStream bais = null;
         ParseXML px = new ParseXML();
 
         String query_string = "p=11" + "&op=next" + "&xml=true" +
                             "&choice=backupkey" +
-                            "&__pwd=" + URLEncoder.encode(backup_pwd) +
-                            "&__pwdagain=" + URLEncoder.encode(backup_pwd);
+                            "&__pwd=" + URLEncoder.encode(backup_pwd, "UTF-8") +
+                            "&__pwdagain=" + URLEncoder.encode(backup_pwd, "UTF-8");
 
         hr = hc.sslConnect(cs_hostname, cs_port, wizard_uri, query_string);
 
@@ -706,7 +711,7 @@ public class ConfigureDRM {
         return true;
     }
 
-    public boolean AdminCertReqPanel() {
+    public boolean AdminCertReqPanel() throws UnsupportedEncodingException {
         HTTPResponse hr = null;
         ByteArrayInputStream bais = null;
         ParseXML px = new ParseXML();
@@ -736,19 +741,19 @@ public class ConfigureDRM {
                             "&cert_request_type=" + "crmf" +
                             "&uid=" + admin_user +
                             "&name=" + admin_user +
-                            "&__pwd=" + URLEncoder.encode(admin_password) +
-                            "&__admin_password_again=" + URLEncoder.encode(admin_password) +
+                            "&__pwd=" + URLEncoder.encode(admin_password, "UTF-8") +
+                            "&__admin_password_again=" + URLEncoder.encode(admin_password, "UTF-8") +
                             "&profileId=" + "caAdminCert" +
                             "&email=" +
-                            URLEncoder.encode(admin_email) +
+                            URLEncoder.encode(admin_email, "UTF-8") +
                             "&cert_request=" +
-                            URLEncoder.encode(admin_cert_request) +
+                            URLEncoder.encode(admin_cert_request, "UTF-8") +
                             "&subject=" +
-                            URLEncoder.encode(agent_cert_subject) +
+                            URLEncoder.encode(agent_cert_subject, "UTF-8") +
                             "&clone=new" +
                             "&import=true" +
                             "&securitydomain=" +
-                            URLEncoder.encode(domain_name);
+                            URLEncoder.encode(domain_name, "UTF-8");
 
         hr = hc.sslConnect(cs_hostname, cs_port, wizard_uri, query_string);
 
@@ -800,14 +805,14 @@ public class ConfigureDRM {
         return true;
     }
 
-    public boolean UpdateDomainPanel() {
+    public boolean UpdateDomainPanel() throws UnsupportedEncodingException {
         HTTPResponse hr = null;
         ByteArrayInputStream bais = null;
         ParseXML px = new ParseXML();
 
         String query_string = "p=14" + "&op=next" + "&xml=true" +
-                            "&caHost=" + URLEncoder.encode(sd_hostname) +
-                            "&caPort=" + URLEncoder.encode(sd_agent_port);
+                            "&caHost=" + URLEncoder.encode(sd_hostname, "UTF-8") +
+                            "&caPort=" + URLEncoder.encode(sd_agent_port, "UTF-8");
 
         hr = hc.sslConnect(cs_hostname, cs_port, wizard_uri, query_string);
 
@@ -819,7 +824,7 @@ public class ConfigureDRM {
         return true;
     }
 
-    public boolean ConfigureDRMInstance() {
+    public boolean ConfigureDRMInstance() throws UnsupportedEncodingException {
         // 0. login to cert db
         ComCrypto cCrypt = new ComCrypto(client_certdb_dir,
                                         client_certdb_pwd,
@@ -980,7 +985,7 @@ public class ConfigureDRM {
         }
     }
 
-    public static void main(String args[]) {
+    public static void main(String args[]) throws UnsupportedEncodingException {
         ConfigureDRM ca = new ConfigureDRM();
 
         // set variables
@@ -1016,7 +1021,6 @@ public class ConfigureDRM {
         StringHolder x_base_dn = new StringHolder();
         StringHolder x_db_name = new StringHolder();
         StringHolder x_secure_conn = new StringHolder();
-        StringHolder x_clone_start_tls = new StringHolder();
         StringHolder x_remove_data = new StringHolder();
 
         // key properties (defaults)
@@ -1077,6 +1081,9 @@ public class ConfigureDRM {
         StringHolder x_clone_uri = new StringHolder();
         StringHolder x_clone_p12_file = new StringHolder();
         StringHolder x_clone_p12_passwd = new StringHolder();
+        StringHolder x_clone_master_port = new StringHolder();
+        StringHolder x_clone_replica_port = new StringHolder();
+        StringHolder x_clone_replication_security = new StringHolder();
 
         // parse the args
         ArgParser parser = new ArgParser("ConfigureDRM");
@@ -1138,9 +1145,6 @@ public class ConfigureDRM {
         parser.addOption("-secure_conn %s #use ldaps port (optional, default is false)", x_secure_conn);
         parser.addOption("-remove_data %s #remove existing data under base_dn (optional, default is false) ",
                 x_remove_data);
-        parser.addOption(
-                "-clone_start_tls %s #use startTLS for cloning replication agreement (optional, default is false)",
-                x_clone_start_tls);
 
         // key and algorithm options (default)
         parser.addOption("-key_type %s #Key type [RSA,ECC] (optional, default is RSA)", x_key_type);
@@ -1240,6 +1244,15 @@ public class ConfigureDRM {
                 x_clone_p12_file);
         parser.addOption("-clone_p12_password %s #Password for pk12 file (optional, required if -clone=true)",
                 x_clone_p12_passwd);
+        
+        // replication agreement options
+        parser.addOption("-clone_master_port %s #Master Port to be used in replication agreement (optional)",
+                x_clone_master_port);
+        parser.addOption("-clone_replica_port %s #Replica Port to be used in replication agreement (optional)",
+                x_clone_replica_port);
+        parser.addOption("-clone_replication_security %s #Type of security in replication agreement (optional)",
+                x_clone_replication_security);
+        
 
         // and then match the arguments
         String[] unmatched = null;
@@ -1285,7 +1298,6 @@ public class ConfigureDRM {
         db_name = x_db_name.value;
         secure_conn = set_default(x_secure_conn.value, "false");
         remove_data = set_default(x_remove_data.value, "false");
-        clone_start_tls = set_default(x_clone_start_tls.value, "false");
 
         key_type = set_default(x_key_type.value, DEFAULT_KEY_TYPE);
         transport_key_type = set_default(x_transport_key_type.value, key_type);
@@ -1344,6 +1356,9 @@ public class ConfigureDRM {
         clone_uri = x_clone_uri.value;
         clone_p12_file = x_clone_p12_file.value;
         clone_p12_passwd = x_clone_p12_passwd.value;
+        clone_master_port = set_default(x_clone_master_port.value, "");
+        clone_replica_port = set_default(x_clone_replica_port.value, "");
+        clone_replication_security = set_default(x_clone_replication_security.value, "None");
 
         boolean st = ca.ConfigureDRMInstance();
 
